/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Interfaces.h"

namespace morpheo              {
namespace behavioural          {

#undef  FUNCTION
#define FUNCTION "Interfaces::set_interface"
  Interface_fifo * Interfaces::set_interface (std::string         name        
#ifdef POSITION
					      ,direction_t    direction   
					      ,localisation_t localisation
#endif
					      )
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
    
    Interface_fifo * interface = new Interface_fifo (name
#ifdef POSITION
						     ,direction
						     ,localisation
#endif
						     ,_usage);
    
    _list_interface->push_back (interface);

    log_printf(FUNC,Behavioural,FUNCTION,"End");
     return interface;
  };

#ifdef POSITION
#undef  FUNCTION
#define FUNCTION "Interfaces::set_interface"
  Interface_fifo * Interfaces::set_interface (std::string         name        ,
					      direction_t    direction   ,
					      localisation_t localisation,
					      std::string         comment     )
  {
    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
    Interface_fifo * interface = set_interface(name, direction, localisation);
    
    interface->set_comment (comment);

    log_printf(FUNC,Behavioural,FUNCTION,"End");
    return interface;
  };
#endif

}; // end namespace behavioural          
}; // end namespace morpheo              
